<p-blockUI [target]="pnl" [blocked]="blockedPanel">
    <i class="pi pi-spin pi-spinner" style="font-size: 3rem"></i>
</p-blockUI>
<div class="grid">
    <div class="col-12">
        <div class="card">
            <h5 class="text-blue-500 font-bold"><i class="pi pi-users text-4xl"></i>จัดการผู้ใช้</h5>
            <p-table #pnl [value]="users" scrollDirection="both" [paginator]="true" [rows]="10" [scrollable]="true"
                [showCurrentPageReport]="true" styleClass="mt-3" responsiveLayout="scroll" [rowHover]="true"
                currentPageReportTemplate="Showing {first} to {last} of {totalRecords} entries"
                [rowsPerPageOptions]="[10,25,50]" [globalFilterFields]="['username','hospital_name','fullname']">
                <ng-template pTemplate="caption">
                    <div class="flex flex-wrap gap-2 align-items-center justify-content-between">
                        <span class="p-input-icon-left w-full sm:w-20rem flex-order-1 sm:flex-order-0">
                            <i class="pi pi-search"></i>
                            <input pInputText type="text" (input)="onGlobalFilter(pnl, $event)" placeholder="ค้นหา"
                                class="w-full" />
                        </span>
                        <button (click)="displayFormAdd()" pButton
                            class="p-button w-full sm:w-auto flex-order-0 sm:flex-order-1"
                            icon="pi pi-plus-circle" label="เพิ่มผู้ใช้"></button>
                    </div>
                </ng-template>
                <ng-template pTemplate="header">
                    <tr>
                        <th class="text-center">ลำดับ</th>
                        <th pSortableColumn="fullname">ชื่อ-นามสกุล <p-sortIcon field="fullname"></p-sortIcon></th>
                        <th pSortableColumn="position">ตำแหน่ง <p-sortIcon field="position"></p-sortIcon></th>
                        <th pSortableColumn="hospital_name">หน่วยบริการ <p-sortIcon field="hospital_name"></p-sortIcon></th>
                        <th pSortableColumn="username">Username <p-sortIcon field="username"></p-sortIcon></th>
                        <th class="text-center" pSortableColumn="is_active" style="width:160px;">สถานะการใช้งาน <p-sortIcon field="is_active"></p-sortIcon></th>
                        <th class="text-center"></th>
                    </tr>
                </ng-template>
                <ng-template pTemplate="body" let-user let-i="rowIndex">
                    <tr>
                        <td class="text-center">{{i+1}}</td>
                        <td>{{user.profile.fullname}}</td>
                        <td>{{user.profile.position}}</td>
                        <td>{{user.hospital.hospital_name }}</td>
                        <td>{{user.username}}</td>
                        <td class="text-center" >
                            <p-tag *ngIf="user.is_active" severity="success" value="เปิดใช้งาน"></p-tag>
                            <p-tag *ngIf="!user.is_active" severity="danger" value="ปิดใช้งาน"></p-tag>
                        </td>
                        <td class="text-center">
                            <button type="button" pButton pRipple icon="pi pi-pencil"
                                class="h-1rem mr-2 p-button-warning p-button-raised" (click)="displayFormEdit(user)" pTooltip="แก้ไขข้อมูล" tooltipPosition="bottom"></button>
                        </td>
                    </tr>
                </ng-template>

            </p-table>
        </div>
    </div>

    <p-dialog [(visible)]="displayForm" [style]="{ width: '50vw' }">
        <ng-template pTemplate="header">
            <h5 *ngIf="isAdd">เพิ่มผู้ใช้</h5>
            <h5 *ngIf="isEdit">แก้ไขผู้ใช้</h5>
            <p-messages
            [(value)]="messages"
            [enableService]="false"
            [closable]="false"
        ></p-messages>
        </ng-template>
        <ng-template pTemplate="content">
            <!-- เพิ่มผู้ใช้ -->
            <div *ngIf="isAdd" class="p-fluid">
                <!-- <h5>เพิ่มผู้ใช้</h5> -->
                <div class="grid">

                    <div class="col-12 md:col-4">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-chevron-circle-right"></i></span>
                            <input type="text" id="title" [(ngModel)]="title" pInputText placeholder="คำนำหน้า">
                        </div>
                    </div>
                    <div class="col-12 md:col-8">

                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-chevron-circle-right"></i></span>
                            <input type="text" id="fullname" [(ngModel)]="fullname" pInputText
                                placeholder="ชื่อ-นามสกุล">
                        </div>
                    </div>
                    <div class="col-12 md:col-6">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-id-card"></i></span>
                            <input type="text" id="cid" [(ngModel)]="cid" pInputText
                                placeholder="เลขบัตรประจำตัวประชาชน" maxlength="13">
                        </div>
                    </div>
                    <div class="col-12 md:col-6">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-users"></i></span>
                            <input type="text" id="position" [(ngModel)]="position" pInputText placeholder="ตำแหน่ง">
                        </div>
                    </div>
                    <div class="col-12 md:col-6">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-phone"></i></span>
                            <input type="text" id="phone_number" [(ngModel)]="phone_number" pInputText
                                placeholder="เบอร์โทรศัพท์">
                        </div>
                    </div>
                    <div class="col-12 md:col-6">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-lock"></i></span>
                            <input type="text" id="password" [(ngModel)]="passWord" pInputText placeholder="Password">
                        </div>
                    </div>
                    <div class="col-12 md:col-4">
                        <h5>สิทธิ์การเข้าถึง</h5>
                        <p-dropdown appendTo="body" [options]="rolesall" [(ngModel)]="selectedDrop"
                            optionLabel="role_name" [showClear]="true"  (onChange)="showDropdown(selectedDrop.role_id)"></p-dropdown>
                    </div>
                    <div class="col-12 md:col-4" *ngIf="is_hospital">
                        <h5>หน่วยบริการ</h5>
                        <p-dropdown appendTo="body" [options]="hospitals" [(ngModel)]="hospitalId"
                            optionLabel="hospital_name" [showClear]="true" optionValue="hospital_id"></p-dropdown>
                    </div>
                    <div class="col-12 md:col-4" *ngIf="is_service">
                        <h5>จุดบริการ</h5>
                        <p-dropdown appendTo="body" [options]="services" [(ngModel)]="serviceId"
                            optionLabel="service_name" [showClear]="true" optionValue="service_id"></p-dropdown>
                    </div>
                </div>
            </div>

            <!-- แก้ไขผู้ใช้ -->
            <div *ngIf="isEdit" class="p-fluid">
                <div class="grid">
                    <div class="col-12 md:col-4">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-id-card"></i></span>
                            <input type="text" id="cid" [(ngModel)]="cidEdit" pInputText
                                placeholder="เลขบัตรประจำตัวประชาชน" [disabled]="true" />
                        </div>
                    </div>
                    <div class="col-12 md:col-3">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-chevron-circle-right"></i></span>
                            <input type="text" id="title" [(ngModel)]="tiTleEdit" pInputText placeholder="คำนำหน้า">
                        </div>
                    </div>
                    <div class="col-12 md:col-5">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-chevron-circle-right"></i></span>
                            <input type="text" id="fullname" [(ngModel)]="fullNameEdit" pInputText
                                placeholder="ชื่อ-นามสกุล">
                        </div>
                    </div>
                    <div class="col-12 md:col-6">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-users"></i></span>
                            <input type="text" id="position" [(ngModel)]="posiTionEdit" pInputText
                                placeholder="ตำแหน่ง">
                        </div>
                    </div>
                    <div class="col-12 md:col-6">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-phone"></i></span>
                            <input type="text" id="phone_number" [(ngModel)]="phoneNumberEdit" pInputText
                                placeholder="เบอร์โทรศัพท์">
                        </div>
                    </div>
                    <div class="col-12 md:col-6">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-user"></i></span>
                            <input type="text" id="userNameEdit" [(ngModel)]="userNameEdit" pInputText
                                placeholder="Username" [disabled]="true" />
                        </div>
                    </div>
                    <div class="col-12 md:col-6">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-lock"></i></span>
                            <input type="text" id="passWordEdit" [(ngModel)]="passWordEdit" pInputText
                                placeholder="Password">
                        </div>
                    </div>
                    <div class="col-12 md:col-4">
                        <h5>สิทธิ์การเข้าถึง</h5>
                        <p-dropdown appendTo="body" [options]="rolesall" [(ngModel)]="selectedDrop" id="selectedDrop" 
                            optionLabel="role_name" [showClear]="true"  (onChange)="showDropdown(selectedDrop.role_id)"></p-dropdown>
                    </div>
                    <div class="col-12 md:col-4" *ngIf="is_hospital">
                        <h5>หน่วยบริการ</h5>
                        <p-dropdown appendTo="body" [options]="hospitals" [(ngModel)]="hospitalId"
                            optionLabel="hospital_name" [showClear]="true" optionValue="hospital_id"></p-dropdown>
                    </div>
                    <div class="col-12 md:col-4" *ngIf="is_service">
                        <h5>จุดบริการ</h5>
                        <p-dropdown appendTo="body" [options]="services" [(ngModel)]="serviceId"
                            optionLabel="service_name" [showClear]="true" (onChange)="showDropdownService()" optionValue="service_id"></p-dropdown>
                    </div>
                    <div class="col-12 md:col-12">
                        <h5>สถานะการใช้งาน</h5>
                        <p-inputSwitch [(ngModel)]="userActiveEdit"></p-inputSwitch>

                    </div>
                </div>
            </div>
        </ng-template>
        <ng-template pTemplate="footer">
            <button *ngIf="isAdd" type="button" pButton icon="pi pi-check" class="p-button-raised p-button-success"
                (click)="save()" label="เพิ่มรายการ"></button>
            <button *ngIf="isEdit" type="button" pButton icon="pi pi-check" class="p-button-raised p-button-success"
                (click)="update()" label="บันทึกแก้ไข"></button>
        </ng-template>
    </p-dialog>
</div>